int maximo_tiro =20; //numero maximo de tiros na tela
boolean mouseapertado;
int score; //placar
PFont Tahoma;
int record; //record


 // declarar vetores
 float vet_x[]; //posição x
 float vet_y[]; //posição y
 float vet_r[]; //raio dos cometas
 int n;       // número de cometas
 color fixo[];

 
 //vetor dos tiros
 int tirox[];
 int tiroy[];

 
 //incrementos da velocidade dos cometas
 float vel[];
 float angulo[]; 
 
 
 
 
 
void setup()
{ 
  size(400,800);
  background(0);
  noStroke();
  smooth();
  ellipseMode (CENTER);
  fill (random(0,255),random(0,255),random (0,255),random(100,255));
  rectMode (CENTER);
  
  
  //Placar
  Tahoma = loadFont("Tahoma-Bold-20.vlw");
  textFont (Tahoma);
  
  // Espaço dos vetores
  //3 bolas no inicío.
  //característica dos vetores
  
//mouseapertado = true;
 n = 4;
 vet_x = new float [n];
 vet_y = new float [n];
 vet_r = new float [n];
 vel = new float [n];
 angulo = new float [n];
 fixo = new color[n];
 
 tirox = new int [maximo_tiro];
 tiroy = new int [maximo_tiro];
 
 //inicia os vetores
 for (int i=0; i<n; i++){
   //características dos cometas
   vet_x[i] = (float)(random(0,width));
   vet_y[i] = (float)(0);
   vet_r[i] = (float)random(10,30);
   vel[i] = random(2,5);
   angulo[i] = (float)random(PI*7/6, PI*11/6); //angulo em que os cometas descem... esse angulo foi colocado para que os cometas reabtam nas paredes
   fixo [i] = color(random(50,255),random(50,255),random(50,255),255);
  } 
  for (int j=0; j<maximo_tiro; ++j){
    tiroy[j] = -50; //tiros existem fora da tela....são chamados conforme se atira
  }
}


void mouseReleased() {
  mouseapertado = false;
}


void draw()
{
 //sensação de blur na tela
  fill(0,15); 
  rect(width/2,height/2,width,height);
  
  for (int i=0; i<n; ++i){
    
  //Desenhar cometas
  fill(fixo[i]);
  ellipse (vet_x[i],vet_y[i],vet_r[i]*2,vet_r[i]*2);
      //Movimento dos cometas
  vet_x[i] = vet_x[i] + cos (angulo[i])*vel[i];
  vet_y[i] = vet_y[i] + -sin (angulo[i])*vel[i];
  
  //Rebater nas paredes
  if (vet_x[i]<=0){
    angulo[i] = random(PI*5/3, PI*11/6);  //inverte sentido em x
  }
  
  if (vet_x[i]>=width-vet_r[i]*2){
    angulo[i] = random(PI*7/6, PI*4/3);  
    
  }
    
  if (vet_y[i]>=height){
    vet_x[i] = (random(0,width));
    vet_y[i] = 0;
    vet_r[i] = random(10,30);
    angulo[i] = (float)random(PI*7/6, PI*11/6);
    fixo [i] = color(random(50,255),random(50,255),random(50,255),255);
    score--; //cada coemta que sai da tela vale menos 1 ponto
  }
   

 
    
   }
   

  if (mousePressed && mouseapertado == false) {
    mouseapertado = true;
    for (int j=0; j<maximo_tiro; ++j){  
      if (tiroy[j] < 0) {
        tirox[j] = mouseX;
        tiroy[j] = mouseY;
        break; //faz com que os tiro sejam independentes, assim pode-se atirar vários...pára uma função e chama de novo sem invalidar a anterior
      }
    }
  }
  
  
 for (int j=0; j<maximo_tiro; ++j){
  //função que faz o tiro subir e dá sua velocidade
  tiroy[j] = tiroy[j] - 10;
  
 //função que desenha o tiro
  fill(255);
  rect(tirox[j], tiroy[j], 5,20); 
 }      

//colisões
//se o tiro e o cometa se acertarem, o tiro vota pra posição -50 e um novo cometa é sorteado.
for(int i=0; i<n; i++){
   for (int j=0; j<maximo_tiro; ++j){
     if (dist(tirox[j], tiroy[j], vet_x[i], vet_y[i])< vet_r[i]){
       tiroy[j] = -50;
       vet_x[i] = (random(0,width));
       vet_y[i] = 0;
       vet_r[i] = random(10,30);
       vel[i] = vel[i] + 0.2;
       angulo[i] = (float)random(PI*7/6, PI*11/6);
       fixo [i] = color(random(50,255),random(50,255),random(50,255),255);
       score++;//cada cometa acertado vale 1 ponto
   }
 }
}


fill(255);
text("Pontos: " + score, 20,40);
text("Recorde: " + record, 20,80);

if (score >record){
record = score;
}


}

  
  
 



